/*
 *  Tcpjunk - TCP protocols testing tool
 *  Contact: oferkv@gmail.com
 *
 *  Tcpjunk is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2, or (at your option) any
 *  later version.
 *
 *  Tcpjunk is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */

#ifndef NET_H
#define NET_H

#include <openssl/crypto.h>
#include <openssl/ssl.h>
#include <openssl/err.h>

int connect_tcp(struct tj_data *inst_data, int sock);

void
disconnect_tcp(int sock, struct tj_data *inst_data, SSL *ssl, SSL_CTX *ctx);

int read_reply_tcp(int sock, SSL *ssl, struct tj_data *inst_data);

void send_data_tcp(int sock, SSL *ssl, struct tj_data *inst_data,
	char *send_buf, int send_buf_len);

struct addrinfo *check_address(struct tj_data *inst_data, const char *addr,
	char *port, int passive);

int check_src_address(struct tj_data *inst_data, char *addr);

int set_src_ip(struct tj_data *inst_data, char *bind_if_name, char *new_src_ip);

void show_peer_addr(struct tj_data *inst_data, int cl_socket);

char *addr_ntop(const struct sockaddr *sa, socklen_t salen);

#endif

